(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenC_front.sml,v
   Comment: front part common to all C code generators
   Release: scope-0-15_final 

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   
   CodGenC_front.sml,v 1.2 2003/07/23 21:08:56 wasowski Exp
*)

structure CodGenC_front = struct

open Common LR 
(* compile signals. Only look at nonempty, nonsingle signals.
   The rest is optimized anyway *)

val alloc = UList.alloc

fun comp_signals (actions :actions) :signals =
	let fun comp_signal (a,e) = case signals a of 
		  [] => e | [s] => e
		| sigs => #2 (alloc (map (LREventRef o #1) sigs @ [LRNoEvent]
					,e))
	in UList.foldl comp_signal (UList.initialize sigsize) actions end

(* propose length for signal queue *)

fun comp_queuelen (queuelen :int) (evtypes :evtype env) :int option =
	if List.exists (#1 o #2) (SE.toList evtypes) 
	then SOME queuelen 
	else NONE

end
