(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/acfg/ACFT.sml,v
   Comment: Simple implementation of ACFGs (in form ofnon reduced trees)
   Release: scope-0-15_final

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   ACFT.sml,v 1.5 2003/01/22 16:08:08 wasowski Exp 
*)

structure ACFT :> ACFG = struct

	(* convention: ''a is a condition type and ''b is an action type *)

	datatype (''a,''b) test = Test of ''a * (''a,''b) acfg * (''a,''b) acfg
	and      (''a,''b) acfg = ACFG of ''b list * (''a,''b) test list

	fun actions (ACFG (acs,_)   ) = acs
	fun tests   (ACFG (_,splits)) = splits

	fun cond    (Test ( con,_,_)) = con
	fun lo      (Test (_,lseq,_)) = lseq
	fun hi      (Test (_,_,hseq)) = hseq

	fun is_leaf (ACFG (_,[])) = true
	  | is_leaf  _		  = false

end
