#!/usr/bin/perl -w 
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/prepspeed.pl,v
# Comment: Compile executables for tests of reactoin speed (smoke method)
# Release: scope-0-15_final
#
#    Copyright (C) 2001-2002 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# NOTES:
#
# prepspeed.pl,v 1.6 2003/07/28 14:33:28 wasowski Exp

use File::stat;
use File::Basename;
use test::src::ScopeTest;

$codgen   = "C1";
$compiler = "";
$outdir   = ".";
$preopts  = "";

if (! $ARGV[0]) {
	print "\n prepspeed.pl codgen [output_dir [ lcc|gcc [preopts]]]\n\n";
	exit;
}

if ($ARGV[0]) { $codgen=$ARGV[0]; }
if ($ARGV[1]) { $outdir   = $ARGV[1]; }
if ($ARGV[2]) { $compiler = $ARGV[2]; }
if ($ARGV[3]) { $preopts  = $ARGV[3]; }

system "mkdir $outdir 2> /dev/null";


$pos = 0;
@cases = ( "test/run/actions01.vsp",  "2",   "0", 
	   "test/run/Lift.vsp",       "100000", "3",
	   "test/run/peer.vsp",       "1000000","50",	
	   "test/run/cdplayer.vsp",   "1000000","10",
   	   "test/run/climate.vsp",    "1000000","12",
   	   "test/run/Clockradio.vsp", "1000000","13",
   	   "test/run/mobile.vsp",     "1000000","13",
   	   "test/run/mobileflat.vsp", "1000000","14",
   	   "test/run/drusinsky89.vsp","1000000","13",
   	   "test/run/trios01.vsp",    "1000000","3",
   	   "test/run/trios02.vsp",    "1000000","3",
           "test/run/trios03.vsp",    "1000000","3" 
  );

sub testsmoke() {

	my $file    = $cases[$pos];
	my $fbase = fileparse($file,qr/\.[^.]*/);
	return ((system "compilespeed.pl $file $codgen sandbox/ $compiler $preopts > /dev/null") == 0
		&& (system "mv sandbox/$fbase $outdir") == 0);
}

ScopeTest::test_init( "CodGen$codgen compiling for reaction speed test" );

$success = 1;

for( $pos = 0; defined( $cases[$pos] ); $pos = $pos +3 ) {
	
	$success = ScopeTest::dotest(\&testsmoke, $cases[$pos]) && $success;
}
        

ScopeTest::test_finalize( $success );

