(*
  File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tWuddySys.sml,v
  Comment: testing WuddySys module
  Release: scope-0-15_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  
  NOTES: This only tests one aspect currently: exist orstates phi_h <=> phi_f 
  for flat models. This is actually one of the ways to detect flat models
  (with arbitrarily distorted concurrency level). But I am not sure it
  actually detects flateness. It maybe only detects hierarchy, sometimes
  missing it. You can see some interesting observations if this test procedure
  is run over all cases in LIST file, instead of those enumerated here.

  tWuddySys.sml,v 1.2 2003/07/05 18:31:05 wasowski Exp 
*) 

app load ["Haskellish", "Process", "FileSys", "Say", "Test", "Absyn", "AbsynPrint", 
          "VsrAbsyn", "parse", "AbsynLogic", "Normalise", "StaticScope",
          "flatten", "Stat" ];

open Say Test Haskellish List Absyn Flatten;
infixr 0 $;

infix 7 AND
infix 6 OR
infix 4 IMP BIIMP

val testname = "WuddySys.sml";

type testspec = string (* filename *)

val testcases : testspec list = [ "test/run/actions01.vsp", 
				  "test/run/actions02.vsp",
                                  "test/run/Lift.vsp",
				  "test/run/mobileflat.vsp"];

(* FIXME: add more test cases when you have access to visual models *)

fun testf (fname :testspec) :bool =
      let val model = VsrAbsyn.translate (parse.parse fname NONE)
          val sys   = hd model; (* only single system models supported *)
          val phi_h = build (getroot (#hierarchy sys))
          val phi_f = build_flat  (getroot (#hierarchy sys))
	  val orsts = Stat.list_orst sys
	  val vset  = makeset orsts 
      in always (exist vset phi_h BIIMP phi_f) end;

val _ = Test.init testname; 
val _ = bdd.init 10000 10000;

val _   = setverbosity VNorm;
val res = map (fn t => test testf t (" " ^ t)) testcases;

val _ = Test.finalise testname res  
val _ = bdd.done();



	  

