(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/use.sml,v
   Comment: Stub file to load what is needed to use scope interactively in mosml
   Release: scope-0-15_final

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   This file is not being linked in into the main executable. Its role is
   merely to aid testing.
   
   To open a test session in interactive environment issue:
   
         $ make
         $ make debug

   in scope source directory
   
   use.sml,v 1.19 2003/07/29 16:46:18 wasowski Exp *)

  fun q () = quietdec := not (!quietdec);

  (* become silent *)

  q();


  (* load & link *)

  List.app load ["Symbol","vsr","Absyn","parse",
		 "Unparse","VsrAbsyn","Interpr","Main","PP", "WuddySys"];

  (* Pretty printers *)

  use "PPSymbol.sml";

  (* test cases *)

  val cdp   = "test/parser/CDPlayer.vsr";
  val avs   = "test/parser/AvSystem.vsp";
  val cdplayer = "test/run/cdplayer.vsp";
  val climate = "test/run/climate.vsp";
  val clockradio = "test/run/Clockradio.vsp";
  val drusinsky89 = "test/run/drusinsky89.vsp";
  val peer  = "test/run/peer.vsr";
  val motor = "test/run/motor.vsr";
  val neg01 = "test/run/neg01.vsp";
  val neg02 = "test/run/neg02.vsp";
  val neg03 = "test/run/neg03.vsp";
  val actions03 = "test/run/actions03.vsp";
  val actions02 = "test/run/actions02.vsp";
  val actions01 = "test/run/actions01.vsp";
  val trans03   = "test/run/trans03.vsp";
  val trans05   = "test/run/trans05.vsp";
  val trans06   = "test/run/trans06.vsp";
  val trans11   = "test/run/trans11.vsp";
  val trans12   = "test/run/trans12.vsp";
  val trans13   = "test/run/trans13.vsp";
  val history01 = "test/run/history01.vsp";
  val history02 = "test/run/history02.vsp";
  val history03 = "test/run/history03.vsp";
  val history04 = "test/run/history04.vsp";
  val lift      = "test/run/Lift.vsp";
  val signals01 = "test/run/signals01.vsp";
  val signals02 = "test/run/signals02.vsp";
  val signals03 = "test/run/signals03.vsp";
  val trios01   = "test/run/trios01.vsp";
  val trios02   = "test/run/trios02.vsp";
  val trios03   = "test/run/trios03.vsp";

  val currmodel = history04;

  (* open *)

  open VsrAbsyn Main Absyn Interpr 

  structure W = WuddySys;
  structure S = Symbol;

(*  val _ = setverbosity VHigh; *)

  W.init();

  fun prh (h :'aor hierarchy) =  map (#1 o #2) (Intmap.listItems (#2 h));
  
  val m = translate (parse currmodel NONE)
      handle e => Err.exnhandler e (fn ()=> raise Fail "Terminated.");

  val s = hd (Main.regularize m);
  val h = #hierarchy s;
  val (a,ms) = Flatten.fl_hierarchy h;
  val f = Flatten.fl_sys s handle e =>exnhandler1 e;
  
  val _ = print ("current model : " ^ currmodel ^ "\n");
  val _ = print "s-system, h-hierarchy, a-anatomy, f-flat system\n";

  (*val mg = init s
      handle e => Err.exnhandler e (fn ()=> raise Fail "Terminated."); 

  printVal mg;
      *)

  val phi_h = W.build (getroot h);
  val phi_f = W.build_flat (getroot h);

  use "test/src/init.sml";
  
  q();	  

  val dict = prh h;
